apiVersion: {{ sts_apivers }}
kind: StatefulSet
metadata:
  labels:
    {{ network_policy_deployment_label }}: {{ loki_name }}
  name: {{ loki_name }}
  namespace: {{ namespace }}
spec:
  podManagementPolicy: Parallel
{% if loki_storage == 'fs' %}
  replicas: 1
{% else %}
  replicas: {{ loki_replicas }}
{% endif %}
  selector:
    matchLabels:
      name: {{ loki_name }}
  serviceName: {{ loki_name }}
  template:
    metadata:
      labels:
        name: {{ loki_name }}
    spec:
{% if do_affinities | default(True) %}
      affinity:
        podAntiAffinity:
{% if scheduling_affinity_required %}
          requiredDuringSchedulingIgnoredDuringExecution:
          - labelSelector:
              matchExpressions:
              - key: name
                operator: In
                values: [ {{ loki_name }} ]
            topologyKey: {{ k8s_affinity_zone_label }}
{% else %}
          preferredDuringSchedulingIgnoredDuringExecution:
          - podAffinityTerm:
              labelSelector:
                matchExpressions:
                - key: name
                  operator: In
                  values: [ {{ loki_name }} ]
              topologyKey: {{ k8s_affinity_zone_label }}
            weight: 42
{% endif %}
{% endif %}
      automountServiceAccountToken: false
      containers:
      - args:
{% if loki_storage != 'fs' and loki_target | default('') in [ 'all', 'read', 'write', 'ingester', 'distributor', 'query-frontend', 'query-scheduler', 'querier', 'index-gateway', 'ruler', 'compactor' ] %}
        - -target={{ loki_target }}
{% else %}
        - -target=all
{% endif %}
        - -config.file=/etc/loki/loki.yaml
        image: {{ (opsimages | json_query("[?name=='loki'].image"))[0] }}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
{% if k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ] %}
          failureThreshold: 38
{% else %}
          failureThreshold: 5
{% endif %}
          initialDelaySeconds: 15
          periodSeconds: 15
          tcpSocket:
            port: 3100
          timeoutSeconds: 5
        name: loki
        ports:
        - name: http
          containerPort: 3100
        - name: gossip
          containerPort: 7946
        - name: grpc
          containerPort: 9095
        readinessProbe:
          httpGet:
            path: /ready
            port: 3100
          initialDelaySeconds: 15
          periodSeconds: 15
          timeoutSeconds: 3
        resources:
          limits:
            cpu: "{{ cpu_limit }}"
            memory: "{{ memory_limit }}"
          requests:
            cpu: "{{ cpu_limit }}"
            memory: "{{ memory_limit }}"
{% if not (k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ]) %}
        startupProbe:
          failureThreshold: 30
          initialDelaySeconds: 15
          periodSeconds: 15
          tcpSocket:
            port: 3100
          timeoutSeconds: 5
{% endif %}
        volumeMounts:
        - mountPath: /loki
          name: data
        - mountPath: /etc/loki/loki.yaml
          name: config
          subPath: loki.yaml
{% if k8s_resource_nodes_selectors | length > 0 %}
      nodeSelector:
{% for sel in k8s_resource_nodes_selectors %}
        {{ sel.split('=')[0] }}: "{{ sel.split('=')[1] if (sel.split('=') | length > 1) else '' }}"
{% endfor %}
{% endif %}
{% if k8s_flavor == 'kubernetes' or (k8s_flavor == 'openshift' and ocp_major in [ 4, '4' ]) %}
      priorityClassName: opsperator-database
{% endif %}
{% if rwo_needs_fsgroup | default(False) or k8s_flavor == 'kubernetes' %}
      securityContext:
{% if rwo_needs_fsgroup | default(False) %}
        fsGroup: {{ rwo_needs_fsgroup }}
{% endif %}
{% if k8s_flavor == 'kubernetes' %}
        runAsUser: {{ k8s_unprivileged_userid }}
{% endif %}
{% endif %}
      terminationGracePeriodSeconds: {{ loki_termination_timeout | default(600) }}
{% if do_topology_spread_constraints | default(False) %}
      topologySpreadConstraints:
      - labelSelector:
          matchLabels:
            name: {{ loki_name }}
        maxSkew: {{ topology_spread_max_skew | default(1) }}
        topologyKey: {{ k8s_affinity_zone_label }}
{% if scheduling_affinity_required %}
        whenUnsatisfiable: DoNotSchedule
{% else %}
        whenUnsatisfiable: ScheduleAnyway
{% endif %}
{% endif %}
      volumes:
{% if loki_storage == 's3' %}
      - secret:
          secretName: {{ loki_name }}
{% else %}
      - configMap:
          name: {{ loki_name }}
{% endif %}
        name: config
  updateStrategy:
    type: RollingUpdate
  volumeClaimTemplates:
  - metadata:
      name: data
    spec:
      accessModes: [ ReadWriteOnce ]
      resources:
        requests:
          storage: "{{ loki_data_capacity }}"
{% if rwo_storage is defined %}
      storageClassName: {{ rwo_storage }}
{% endif %}
